/*******************************************************************************
Copyright © 2023 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

window.CODINGTASK = {
	"heading": "Auftrag",
	"html": "<p>Objekte der Klasse <code>INFORMATIKNOTE</code> sollen jeweils eine Note im Fach Informatik eines Schülers oder einer Schülerin speichern. Programmiere eine Klassendefinition nach folgenden Vorgaben:</p><ol><li><p>Die <code>note</code> hat den Datentyp <code>byte</code>.<p></li><li><p>Ansonsten speichert jedes Objekt nur noch den <code>name</code>n des Schülers oder der Schülerin.<p></li><li><p>Der Konstruktor speichert nur den übergebenen Schüler(innen)namen im Objekt und setzt den Notenwert auf <code>0</code> (für keine Note).<p></li><li><p>Der Name der Schülerin/des Schülers kann nur über einen öffentlichen Getter gelesen werden.<p></li><li><p>Die Note wird nur über einen öffentlichen Setter geändert.<p></li><li><p>Die Note kann nur über einen Getter von Klassen desselben Pakets gelesen werden.<p></li><li><p>Eine öffentliche Methode namens <code>printInfo</code> hat weder Parameter, noch einen Rückgabewert und schreibt zuerst <code>Note von Max Mustermann: </code> (aber mit dem gespeicherten Namen statt <code>Max Mustermann</code> auf die Standardausgabe. Anschließend prüft sie, ob der Wert von <code>note</code> identisch mit <code>0</code> ist. Wenn ja, ergänzt sie <code>noch keine</code> auf der Standardausgabe, andernfalls die Note als Zahl (z. B. <code>2</code>. Verwende für jede der drei beschriebenen Teilausgaben genau einmal <code>print</code>.<p></li></ol><p>Realisiere alle inneren Sequenzen exakt wie beschrieben und mit so wenig Anweisungen wie möglich.</p>",
	"code": "// Hier die Klassendefinition ergänzen\n",
	"canReset": true,
	"labelSubmit": "📥 Klassendefinition überprüfen",
	"checkType": "json",
	"checkData": [
		{
			"part": "class",
			"name": "INFORMATIKNOTE",
			"extends": "Object",
			"implements": [],
			"abstract": false,
			"final": false,
			"static": false,
			"content": [
				{
					"part": "attribute",
					"type": "byte",
					"dimensions": 0,
					"name": "note",
					"static": false,
					"visibility": 0
				},
				{
					"part": "attribute",
					"type": "String",
					"dimensions": 0,
					"name": "name",
					"static": false,
					"visibility": 0
				},
				{
					"part": "constructor",
					"dimensions": 0,
					"static": false,
					"abstract": false,
					"params": [
						{
							"part": "variable",
							"type": "String",
							"dimensions": 0
						}
					],
					"content": [
						"@this.note=0;this.name=@1;",
						"@this.name=@1;this.note=0;",
						"@this.note=0;name=@1;",
						"@name=@1;this.note=0;",
						"@note=0;this.name=@1;",
						"@this.name=@1;note=0;",
						"@note=0;name=@1;",
						"@name=@1;note=0;"
					]
				},
				{
					"part": "method",
					"type": "String",
					"params": [],
					"visibility": 3,
					"content": [
						" return this.name;",
						" return name;"
					]
				},
				{
					"part": "method",
					"type": "void",
					"params": [
						{
							"part": "variable",
							"type": "byte",
							"dimensions": 0
						}
					],
					"visibility": 3,
					"content": [
						"@this.note=@1;",
						"@note=@1;"
					]
				},
				{
					"part": "method",
					"type": "byte",
					"params": [],
					"visibility": 2,
					"content": [
						" return this.note;",
						" return note;"
					]
				},
				{
					"part": "method",
					"type": "void",
					"name": "printInfo",
					"params": [],
					"visibility": 3,
					"content": [
						" print(\"Note von \" + this.name + \": \");if (this.note == 0) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (note == 0) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (note == 0) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + name + \": \");if (this.note == 0) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (this.note == 0) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + name + \": \");if (note == 0) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (note == 0) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == note) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == note) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + name + \": \");if (0 == this.note) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (0 == this.note) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + name + \": \");if (0 == note) { print(\"noch keine\"); } else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (0 == note) { print(\"noch keine\"); } else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (note == 0)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (note == 0)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + name + \": \");if (this.note == 0)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (this.note == 0)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + name + \": \");if (note == 0)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (note == 0)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == note)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + this.name + \": \");if (0 == note)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + name + \": \");if (0 == this.note)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (0 == this.note)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + name + \": \");if (0 == note)print(\"noch keine\"); else { print(this.note); }",
						" print(\"Note von \" + name + \": \");if (0 == note)print(\"noch keine\"); else { print(note); }",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + this.name + \": \");if (note == 0) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (note == 0) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + name + \": \");if (this.note == 0) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + name + \": \");if (this.note == 0) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + name + \": \");if (note == 0) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + name + \": \");if (note == 0) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + this.name + \": \");if (0 == note) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (0 == note) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + name + \": \");if (0 == this.note) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + name + \": \");if (0 == this.note) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + name + \": \");if (0 == note) { print(\"noch keine\"); }else print(this.note);",
						" print(\"Note von \" + name + \": \");if (0 == note) { print(\"noch keine\"); }else print(note);",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (this.note == 0)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + this.name + \": \");if (note == 0)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (note == 0)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + name + \": \");if (this.note == 0)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + name + \": \");if (this.note == 0)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + name + \": \");if (note == 0)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + name + \": \");if (note == 0)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (0 == this.note)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + this.name + \": \");if (0 == note)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + this.name + \": \");if (0 == note)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + name + \": \");if (0 == this.note)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + name + \": \");if (0 == this.note)print(\"noch keine\");else print(note);",
						" print(\"Note von \" + name + \": \");if (0 == note)print(\"noch keine\");else print(this.note);",
						" print(\"Note von \" + name + \": \");if (0 == note)print(\"noch keine\");else print(note);"
					]
				}
			]
		}
	]
}
